{
  "description": "HorizontalPodAutoscalerSpec describes the desired functionality of the HorizontalPodAutoscaler.",
  "properties": {
    "behavior": {
      "$ref": "/api/_definitions.json#/$defs/io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerBehavior",
      "description": "behavior configures the scaling behavior of the target in both Up and Down directions (scaleUp and scaleDown fields respectively). If not set, the default HPAScalingRules for scale up and scale down are used."
    },
    "maxReplicas": {
      "description": "maxReplicas is the upper limit for the number of replicas to which the autoscaler can scale up. It cannot be less that minReplicas.",
      "format": "int32",
      "type": [
        "integer",
        "null"
      ]
    },
    "metrics": {
      "description": "metrics contains the specifications for which to use to calculate the desired replica count (the maximum replica count across all metrics will be used).  The desired replica count is calculated multiplying the ratio between the target value and the current value by the current number of pods.  Ergo, metrics used must decrease as the pod count is increased, and vice-versa.  See the individual metric source types for more information about how each type of metric must respond. If not set, the default metric will be set to 80% average CPU utilization.",
      "items": {
        "$ref": "/api/_definitions.json#/$defs/io.k8s.api.autoscaling.v2.MetricSpec"
      },
      "type": [
        "array",
        "null"
      ],
      "x-kubernetes-list-type": "atomic"
    },
    "minReplicas": {
      "description": "minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down.  It defaults to 1 pod.  minReplicas is allowed to be 0 if the alpha feature gate HPAScaleToZero is enabled and at least one Object or External metric is configured.  Scaling is active as long as at least one metric value is available.",
      "format": "int32",
      "type": [
        "integer",
        "null"
      ]
    },
    "scaleTargetRef": {
      "$ref": "/api/_definitions.json#/$defs/io.k8s.api.autoscaling.v2.CrossVersionObjectReference",
      "description": "scaleTargetRef points to the target resource to scale, and is used to the pods for which metrics should be collected, as well as to actually change the replica count."
    }
  },
  "required": [
    "scaleTargetRef",
    "maxReplicas"
  ],
  "type": "object",
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "$id": "https://kubernetes.io/api/horizontalpodautoscalerspec/autoscaling/v2"
}